/*
DE REPARAT
    GENERAREA PARTITIILOR unui NUMAR
    Sa se determine numarul de posibilitati de a se plati o suma S,
    cu n tipuri de bancnote de valori b[1], .., b[n], stiind ca:
	- Pot fi folosite oricate bancnote din fiecare tip
	- NU Trebuie sa fie utilizata cel putin o bancnota din fiecare tip
*/
#include <fstream>
#include <iostream>
#include <cstring>
using namespace std;

ifstream fin("bancnote.in");
ofstream fout("bancnote.out");

const int MaxN = 50;
const int MaxS = 1000;
int v[MaxN];      //  valorile bancnotelor
int n;            // nr de tipuri de bancnote
int S;            // suma care trebuie obtinuta
int c[MaxS];      // c[j] - nr de moduri in care se poate obtine suma j
void Read();
void Knapsack();

int main()
{
    Read();
    Knapsack();
    if ( c[S] )
        fout << c[S] << '\n';
    else
        fout << "Imposibil\n";
    fin.close();
    fout.close();
    return 0;
}

void Knapsack()
{
    c[0] = 1;    // suma 0 se p obtine intr-un sigur mod: nu pun obiecte
    for (int i = 1; i <= n; ++i )
        for ( int j = 0; j <= S - v[i] ; ++j )
            if ( c[j] )
                c[j + v[i]] += c[j]; // c[j + v[i]] = c[j + v[i]] + c[j];
}


void Read()
{
    fin >> S >> n;
    for ( int i = 1; i <= n; ++i )
        fin >> v[i];
}
