/* Se da un rucsac de capacitate maxima G (Kg) si n TIPURI de obiecte
 * de greutari g[1], ..., g[n] si valori v[1],..., v[n]
 * Sa se det Valoarea maxima cu care poate fi incarcat un rucsac 
 * folosind obiecte de cele n tipuri (se poate utiliza acelasi ob de mai 
 * multe ori)
 * Rucsacul nu trebuie sa fie neaparat plin
 */ 
#include <fstream>
using namespace std;

ifstream fin("knapsack.in");
ofstream fout("knapsack.out");

const int MaxN = 100;
const int MaxG = 200;
const int Necalc = -1;
int g[MaxN], v[MaxN], G, n;
int c[MaxG];  // c[j] - costul maxim al unor obiecte cu greutatea totala j

void Read();
int Knapsack();

int main()
{
	Read();
	fout <<  Knapsack();
	
	fin.close();
	fout.close();
}

int  Knapsack()
{
	for (int j = 0; j <= G; ++j)
		c[j] = Necalc;
	c[0] = 0; // nu pun niciun obiect
	
	for (int i = 1; i <= n; ++i)
		for (int j = 0; j <= G - g[i]; ++j )
			if ( c[j] != Necalc && c[j + g[i]] < c[j] + v[i] )
				c[j + g[i]] = c[j] + v[i];
				
	int vmax = 0;
	for (int j = 0; j <= G; ++j)
		vmax = max(vmax, c[j]);
	return vmax;
}

void Read()
{
	fin >> n >> G;
	for (int i = 1; i <= n; ++i)	
		fin >> g[i];
	for (int i = 1; i <= n; ++i)	
		fin >> v[i];
}
