// Afisarea subsirurilor de lungime maxima
// Numararea subsiruri de lungime maxima

#include <fstream>
using namespace std;

ifstream fin("subs.in");
ofstream fout("subs.out");


int n, a[100];

// Bactracking
int x[100];

void Back(int k);
void Write(int k);
bool OK(int k);


// Dinamica O(n^2)
void Dyn();

int L[100];     // l[i] - lungimea maxima a unui subsir crescator care se termina cu a[i]
int nr[100];    // nr[i] - nr de subsiruri de lungime maxima care se termina cu a[i]
int Lmax;       // lung celui mai lung subs. cresc
int nrsol;      // nr total de subs cresc. de lung lmax

int main()
{
    fin >> n;
    for (int i = 1; i <= n; ++i)
        fin >> a[i];
    fin.close();
	//Back(1);
	
    Dyn();
    
    fout << nrsol;
    fout.close();
    return 0;
}


// ================ Dinamica O(n^2) ==============================
void Dyn() 
{
    for (int i = 1; i <= n; ++i)
    {
        L[i] = 1; nr[i] = 1;
        for (int j = 1; j < i; ++j)
        {
            if (a[i] > a[j] && L[i] == L[j] + 1)
                nr[i] += nr[j];
            if (a[i] > a[j] && L[i] < L[j] + 1)
            {
                L[i] = L[j] + 1;
                nr[i] = nr[j];
            }
        }
    }
    
    for (int i = 1; i <= n; ++i)
        Lmax = max(Lmax, L[i]);
        
    for (int i = 1; i <= n; ++i)
        if (L[i] == Lmax) 
			nrsol += nr[i];
}


// ================= Backtracking ==========================

void Back(int k)
{
    if (k > Lmax)   // stim lmax de la dinamica ( sau se mai putea face 
    {               // un backtrack. pt aflarea doar a lui lmax
        Write(k-1);
        return;
    }
    for (int i = x[k-1] + 1; i <= n; ++i)
    {
        x[k] = i;
        if (OK(k))
            Back(k+1);
    }
}

bool OK(int k)
{
    if (a[x[k]] > a[x[k-1]] || k == 1) return true;
    return false;
}


void Write(int k)
{
	nrsol++;
    for (int i = 1; i <= k; ++i)
        fout << a[x[i]] << ' ';
    fout << '\n';
}
