/* Sa se genereze TOATE subsirurile crescatoare ale unui sir
*/ 
#include <fstream>
using  namespace std;

ifstream fin("subs.in");
ofstream fout("subs.out");

const int MaxN = 1000;
int n, a[MaxN]; // sirul citit

// backtracking
int x[MaxN]; // generam pozitii din sirul a
int nrsol;

void Subs(int k);  
void Write(int k);
void Read();
bool Ok(int k);

// Dinamica O(n^2)
void Dyn(); 
int nr[MaxN];      // nr[i] nr de subs cresc care se termina cu a[i]

int main()
{
	Read();
//	x[0] = -1;    // nu e obligatorie pt back
//	Subs(1);
//	fout << "Nr sol: " <<  nrsol << '\n';

	Dyn();
	fout << nrsol;
	
	fin.close();
	fout.close();
	return 0;
}

// ================ Dinamica O(n^2) ====================================

void Dyn()
{
	nrsol = 0;
	for (int i = 0; i < n; ++i)
	{
		nr[i] = 1;  // daca luam doar a[i]
		for (int j = 0; j < i; ++j)
			if ( a[j] < a[i] )
				nr[i] += nr[j];  
		nrsol += nr[i];
	}
}

// ================= Backtracking ===============================

bool Ok(int k)
{
	if ( k == 1 ) return true;
	if (a[x[k - 1]] >= a[x[k]] ) return false;
	return true;
}
void Subs(int k)
{
	if ( k > 1 ) Write(k - 1);
	if ( k > n ) 
		return;

	for (int i = k > 1 ? x[k - 1] + 1 : 0; i < n; ++i)
	{
		x[k] = i;
		if ( Ok(k) )
			Subs(k + 1);
	} 
}

void Write(int p)
{
	nrsol++;
/*	for (int i = 1; i <= p; ++i)
			fout << a[x[i]] << " ";
	fout << '\n';  
*/	
}

void Read()
{
	fin >> n;
	for (int i = 0; i < n; ++i)
		fin >> a[i];
}

