// Determinarea unui ciclu hamiltonian intr-un graf neorientat
#include <fstream>
using namespace std;
const int DIM = 100;

int a[DIM][DIM], m, n;
int s[DIM];
int x[DIM];  // x[i] - nodul vizitat la pasul i
ofstream fout("graf.out");

void Read();
void Afis(int);
int Bun(int);
void Back(int);

int main()
{
	Read();
	x[1] = 1;
	s[1] = 1;
	Back(2);
	fout.close();

	return 0;
}

void Read()
{
	ifstream fin("graf.in");
	int x, y;
	fin >> n >> m;
	for ( int i = 1; i <= m; i++ )
	{
		fin >> x >> y;
		a[x][y] = a[y][x] = 1;
	}
	fin.close();
}

void Back(int i)
{
	if ( i == n + 1 ) Afis(i - 1);
	else 
		for ( int j = 2; j <= n; j++ )
		{
			x[i] = j;
			if ( Bun(i) ) 
			{
				s[j] = 1;
				Back(i + 1);
				s[j] = 0;
			}
		}
}

int Bun(int i)
{
	if ( !a[x[i-1]][x[i]] ) return 0;   // nu este muchie
	if ( s[x[i]] ) return 0;   // nodul x[i] a mai fost vizitat
	if ( i == n && !a[x[i]][x[1]] ) return 0;  // exista lant hamiltonian dar nu exista ciclu hamiltonian
	return 1;
}

void Afis(int i)
{
	for ( int j = 1; j <= i; j++ )
		fout << x[j] << " ";
	fout << x[1];
	fout << "\n";
}


