/*
    Sa se gaseasca un drum elementar de suma K intre nodurile A si B 
    intr-un graf neorientat
*/
#include <cstdio>  
#include <cstdlib> 
using namespace std;
#define INFINIT 10000
#define DIM 100

int c[DIM][DIM];   // matricea costurilor
int s[DIM];        // s[i] =  1; nodul i a fost vizitat
int x[DIM];        // nodurile de pe drumul se la A la B
int sum[DIM];      // sirul sumelor partiale
int n, m, K, A, B; // noduri, muchii, suma, sursa, destinatia

void Read();
void Back(int k);
void Init();
void Write(int k);

int main()
{
	Read();
	x[1] = A;
	s[1] = 1;
	Back(2);

	return 0;
}

void Init()
{
    for ( int i = 1; i <= n; i++ )
		for ( int j = i; j <= n; j++ )
			c[i][j] = c[j][i] = INFINIT;
}

void Read()
{
    freopen("drumk.in", "r", stdin);
	int v1, v2, cost;
	scanf("%d%d", &n, &m);
	Init();
	for ( int i = 0; i < m; i++ )
	{
		scanf("%d%d%d", &v1, &v2, &cost);
		c[v1][v2] = c[v2][v1] = cost;
	}
	scanf("%d%d%d", &K, &A, &B);  // costul, sursa, destinatia
}

void Write(int k)
{
	freopen("drumk.out", "w", stdout);
	for ( int i = 1; i <= k; i++ )
		printf("%d ",  x[i]);
    printf("\n");
}

int OK(int k)
{
    if ( c[x[k-1]][x[k]] == INFINIT ) return 0; // suma 0
	if ( s[x[k]] ) return 0;
	if ( sum[k-1] + c[x[k-1]][x[k]] > K ) return 0;
    sum[k] = sum[k-1] + c[x[k-1]][x[k]];
    return 1;
}   

int Solution(int k)
{
    return sum[k] == K && x[k] == B;
}

void Back(int k)
{
	for ( int i = 2; i <= n; i++ )
    {
        x[k] = i;
        if ( OK(k) )
            if ( Solution(k) ) 
			{
                Write(k);
                exit(0);  // ma opresc la prima solutie
            }    
            else if ( k < n ) 
                 {
                    s[i] = 1;
                    Back(k + 1);
                    s[i] = 0;
                 }    
    }
}

                
